"use strict";

this.name = "Spicy_Pirate_Hermit_AI";

//don't make things too easy, detonate qbombs with psychic powers.
//two consecutial qbombs probably do the job, but let's not tell anyone.
this.cascadeWeaponDetected = function(weapon) {
	this.$mine = weapon;
	//wait for 1 second, feels more "real".
	this.$mineTimer = new Timer(this, this._delayedBlast, 1, 0);
}

this._delayedBlast = function() {
	if (this.$mine.isValid) {
		ship.commsMessage("Q-Bomb detected, countermeasures activated.");
		ship.fireECM();
		this.$mine.explode();
		delete this.$mine;
	}
}

this.aiStarted = function() {
	
	var ai = new worldScripts["oolite-libPriorityAI"].PriorityAIController(this.ship);
	ai.setCommunicationsRole("station");
	
	//only pirates here
	ai.setParameter("oolite_friendlyRoles",["oolite-pirate","oolite-pirate-leader"]);
	
	ai.setParameter("oolite_stationPatrolRole", "pirate");

	ai.setPriorities([
		//launch defences, if attacked at
		{
			preconfiguration: ai.configurationStationValidateTarget,
			condition: ai.conditionInCombat,
			behaviour: ai.behaviourStationLaunchDefenseShips,
			reconsider: 5
		},
		//keep the space around the station occupied with protecting pirates
		{
			configuration: function() {
				var groupCount = ship.group.count;
				//replace destructed patrol ships.
				if (groupCount < 4) {
					//launch 1 - 3 patrol ships at time
					var count = 1 + Math.floor(Math.random() * 3);
					for (var i = 0; i < count; i++) {
						var patrol = ship.launchShipWithRole("pirate");
						//upgrade weapon, if needed.
						if (patrol[i].forwardWeapon === "EQ_WEAPON_PULSE_LASER") {
							patrol[i].forwardWeapon = "EQ_WEAPON_BEAM_LASER";
						}
						ship.group.addShip(patrol);
						patrol.group = ship.group;
						patrol.switchAI("spicy_hermits-pirateAI.js");
					}
				}
			}
		},
		//handle traffic
		{
			configuration: ai.configurationStationReduceAlertLevel,
			behaviour: ai.behaviourStationManageTraffic,
			reconsider: 60
		}
	]);
}
