"use strict";

this.name = "spicy_hermits_ship_script";

this.shipSpawned = function() {
	this.$locatorWS = worldScripts["spicy_hermits_relocator"];
	
	//spawn a couple of grunts around the smuggler version
	if (ship.primaryRole === "rockhermit-chaotic") {		
		var count = 1 + Math.floor(Math.random() * 3);
		var patrol = system.addShips("pirate", count, ship.position, 25E3);
		for (var i = 0; i < patrol.length; i++) {
			ship.group.addShip(patrol[i]);
			patrol[i].group = ship.group;
			patrol[i].switchAI("spicy_hermits-gruntAI.js");
			//these are some small time criminals with small bounties on their heads
			patrol[i].bounty = 5 + Math.round(Math.random() * 10);
			//upgrade weapon, if needed.
			if (patrol[i].forwardWeapon === "EQ_WEAPON_PULSE_LASER") {
				patrol[i].forwardWeapon = "EQ_WEAPON_BEAM_LASER";
			}
		}
	}	

	//spawn a leader and a few pirates around the pirate version
	if (ship.primaryRole === "rockhermit-pirate") {
		var leader = system.addShips("pirate-heavy-fighter", 1, ship.position, 25E3)[0];
		//upgrade weapon, if needed.
		if (leader.forwardWeapon === "EQ_WEAPON_PULSE_LASER") {
			leader.forwardWeapon = "EQ_WEAPON_BEAM_LASER";
		}
		ship.group.addShip(leader);
		leader.group = ship.group;
		ship.group.leader = leader;
		leader.switchAI("spicy_hermits-pirateAI.js");
		
		var count = 3 + Math.floor(Math.random() * 2);
		var patrol = system.addShips("pirate", count, ship.position, 25E3);
		for (var i = 0; i < patrol.length; i++) {
			//upgrade weapon, if needed.
			if (patrol[i].forwardWeapon === "EQ_WEAPON_PULSE_LASER") {
				patrol[i].forwardWeapon = "EQ_WEAPON_BEAM_LASER";
			}
			ship.group.addShip(patrol[i]);
			patrol[i].group = ship.group;
			patrol[i].switchAI("spicy_hermits-pirateAI.js");
		}
		
	}
}

this.shipDied = function() {
	//relocator hook
	if (this.$locatorWS) {
		if (ship.spicy_hermits_original_position) {
			this.$locatorWS._reportDeath(ship.spicy_hermits_original_position);
		}
		else {
			this.$locatorWS._reportDeath(ship.position);
		}
	}
	
	//create 1 - 5 random cargo pods upon death
	var count = 1 + Math.floor(Math.random() * 6);
	var pods = ship.spawn("cargopod", count);
	
	//destruct pods with non-suitable content.
	if (ship.primaryRole === "rockhermit") {
		var suitableContents = ["radioactives", "minerals", "gold", "platinum", "gem_stones"];
	}
	else if (ship.primaryRole === "rockhermit-chaotic") {
		var suitableContents = ["radioactives", "minerals", "gold", "platinum", "gem_stones", "narcotics", "firearms", "slaves"];
	}
	else var suitableContents = null;
	if (suitableContents) {
		for (var i = 0; i < pods.length; i++) {
			if (suitableContents.indexOf(pods[i].commodity) === -1) {
				pods[i].explode();
			}
		}
	}
	
	//pirate hermits are sometimes boobytrapped
	if (ship.primaryRole === "rockhermit-pirate" && Math.random() < 0.1) {
		var qbomb = ship.spawnOne("energy-bomb");
		qbomb.AIScript.shipWasDumped();
	}
}

this.shipBeingAttacked = function(whom) {
	//order those hardheaded morons to stop firing at the base. On top of being lousy aimers, they also have wax in their ears, hence 33.4 % chance of not hearing the order.
	if (whom.isPirate && Math.random() < 0.666) {
		whom.performFlyToRangeFromDestination();
	}
}
