//Star-jellies from star-jellies OXP are spawned as asteroids and as such occasionally spawn close to hermits. Destruction of a star-jelly produces a cascading quirium explosion that takes care of the possible close by hermit too. This script pushes star-jellies, that are spawned in scanner range of a hermit, 25 km farther.

"use strict";

this.name = "spicy_hermits_star-jellies";

this.startUp = function() {
	
	//check for star-jelly oxp
	if (!Ship.keysForRole("star-jelly1")) {
		delete this.startUpComplete;
		delete this.shipExitedWitchspace;
	}
}

//push star-jellies farther from hermits right after the populator.
this.startUpComplete = this.shipWillExitWitchspace = function() {
	
	//find hermits
	var hermitRoles = ["rockhermit", "rockhermit-chaotic", "rockhermit-pirate"];
	var hermits = new Array();
	for (var i = 0; i < hermitRoles.length; i++) {
		hermits = hermits.concat(system.shipsWithRole(hermitRoles[i]));
	}
	
	//find jellies close to hermits and move them farther
	var jellyRoles = ["star-jelly1", "star-jelly2", "star-jelly-egg", "star-jelly-larva"];
	for (var i = 0; i < hermits.length; i++) {
		var hermit = hermits[i];
		var jellies = new Array();
		for (var j = 0; j < jellyRoles.length; j++) {
			jellies = jellies.concat(system.shipsWithRole(jellyRoles[j], hermit, 25E3));
		}
		var hermitPosition = hermit.position;
		for (var j = 0; j < jellies.length; j++) {
			var jelly = jellies[j];
			var hjUnit = jelly.position.subtract(hermitPosition).direction();
			jelly.position = hermitPosition.add(hjUnit.multiply(25E3));
		}
	}
}
